/*
 *
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 * 
 *   http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 *
 */

/*
 * This file is auto-generated by Qpid Gentools v.0.1 - do not modify.
 * Supported AMQP versions:
 *   8-0
 */

#ifndef qpid_framing_AMQP_ClientProxy__
#define qpid_framing_AMQP_ClientProxy__

#include <AMQP_ClientOperations.h>
#include <FieldTable.h>
#include <OutputHandler.h>

namespace qpid {
namespace framing {

class AMQP_ClientProxy : public AMQP_ClientOperations
{
private:
    
    ProtocolVersion version;
    OutputHandler* out;
    AMQP_ClientOperations::AccessHandler* AccessHandlerPtr;
    AMQP_ClientOperations::BasicHandler* BasicHandlerPtr;
    AMQP_ClientOperations::ChannelHandler* ChannelHandlerPtr;
    AMQP_ClientOperations::ConnectionHandler* ConnectionHandlerPtr;
    AMQP_ClientOperations::DtxHandler* DtxHandlerPtr;
    AMQP_ClientOperations::ExchangeHandler* ExchangeHandlerPtr;
    AMQP_ClientOperations::FileHandler* FileHandlerPtr;
    AMQP_ClientOperations::QueueHandler* QueueHandlerPtr;
    AMQP_ClientOperations::StreamHandler* StreamHandlerPtr;
    AMQP_ClientOperations::TestHandler* TestHandlerPtr;
    AMQP_ClientOperations::TunnelHandler* TunnelHandlerPtr;
    AMQP_ClientOperations::TxHandler* TxHandlerPtr;

public:
    AMQP_ClientProxy(OutputHandler* out, u_int8_t major, u_int8_t minor);
    ProtocolVersion& getProtocolVersion() {return version;}
    virtual ~AMQP_ClientProxy() {}

	// Get methods for handlers

    virtual inline AMQP_ClientOperations::AccessHandler* getAccessHandler() { return &access;}
    virtual inline AMQP_ClientOperations::BasicHandler* getBasicHandler() { return &basic;}
    virtual inline AMQP_ClientOperations::ChannelHandler* getChannelHandler() { return &channel;}
    virtual inline AMQP_ClientOperations::ConnectionHandler* getConnectionHandler() { return &connection;}
    virtual inline AMQP_ClientOperations::DtxHandler* getDtxHandler() { return &dtx;}
    virtual inline AMQP_ClientOperations::ExchangeHandler* getExchangeHandler() { return &exchange;}
    virtual inline AMQP_ClientOperations::FileHandler* getFileHandler() { return &file;}
    virtual inline AMQP_ClientOperations::QueueHandler* getQueueHandler() { return &queue;}
    virtual inline AMQP_ClientOperations::StreamHandler* getStreamHandler() { return &stream;}
    virtual inline AMQP_ClientOperations::TestHandler* getTestHandler() { return &test;}
    virtual inline AMQP_ClientOperations::TunnelHandler* getTunnelHandler() { return &tunnel;}
    virtual inline AMQP_ClientOperations::TxHandler* getTxHandler() { return &tx;}

	// Inner class definitions

    // ==================== class Access ====================
    class Access : virtual public AMQP_ClientOperations::AccessHandler
    {
    private:
        OutputHandler* out;
        AMQP_ClientProxy* parent;

    public:
        // Constructors and destructors

        Access(OutputHandler* out, AMQP_ClientProxy* _parent) : 
            out(out) {parent = _parent;}
        virtual ~Access() {}

        // Protocol methods

        virtual void requestOk( u_int16_t channel,
                            u_int16_t ticket );
    }; // class Access

    // ==================== class Basic ====================
    class Basic : virtual public AMQP_ClientOperations::BasicHandler
    {
    private:
        OutputHandler* out;
        AMQP_ClientProxy* parent;

    public:
        // Constructors and destructors

        Basic(OutputHandler* out, AMQP_ClientProxy* _parent) : 
            out(out) {parent = _parent;}
        virtual ~Basic() {}

        // Protocol methods

        virtual void cancelOk( u_int16_t channel,
                            const string& consumerTag );

        virtual void consumeOk( u_int16_t channel,
                            const string& consumerTag );

        virtual void deliver( u_int16_t channel,
                            const string& consumerTag,
                            u_int64_t deliveryTag,
                            bool redelivered,
                            const string& exchange,
                            const string& routingKey );

        virtual void getEmpty( u_int16_t channel,
                            const string& clusterId );

        virtual void getOk( u_int16_t channel,
                            u_int64_t deliveryTag,
                            bool redelivered,
                            const string& exchange,
                            const string& routingKey,
                            u_int32_t messageCount );

        virtual void qosOk( u_int16_t channel );

        virtual void recoverOk( u_int16_t channel );

        virtual void return_( u_int16_t channel,
                            u_int16_t replyCode,
                            const string& replyText,
                            const string& exchange,
                            const string& routingKey );
    }; // class Basic

    // ==================== class Channel ====================
    class Channel : virtual public AMQP_ClientOperations::ChannelHandler
    {
    private:
        OutputHandler* out;
        AMQP_ClientProxy* parent;

    public:
        // Constructors and destructors

        Channel(OutputHandler* out, AMQP_ClientProxy* _parent) : 
            out(out) {parent = _parent;}
        virtual ~Channel() {}

        // Protocol methods

        virtual void alert( u_int16_t channel,
                            u_int16_t replyCode,
                            const string& replyText,
                            const FieldTable& details );

        virtual void close( u_int16_t channel,
                            u_int16_t replyCode,
                            const string& replyText,
                            u_int16_t classId,
                            u_int16_t methodId );

        virtual void closeOk( u_int16_t channel );

        virtual void flow( u_int16_t channel,
                            bool active );

        virtual void flowOk( u_int16_t channel,
                            bool active );

        virtual void openOk( u_int16_t channel );
    }; // class Channel

    // ==================== class Connection ====================
    class Connection : virtual public AMQP_ClientOperations::ConnectionHandler
    {
    private:
        OutputHandler* out;
        AMQP_ClientProxy* parent;

    public:
        // Constructors and destructors

        Connection(OutputHandler* out, AMQP_ClientProxy* _parent) : 
            out(out) {parent = _parent;}
        virtual ~Connection() {}

        // Protocol methods

        virtual void close( u_int16_t channel,
                            u_int16_t replyCode,
                            const string& replyText,
                            u_int16_t classId,
                            u_int16_t methodId );

        virtual void closeOk( u_int16_t channel );

        virtual void openOk( u_int16_t channel,
                            const string& knownHosts );

        virtual void redirect( u_int16_t channel,
                            const string& host,
                            const string& knownHosts );

        virtual void secure( u_int16_t channel,
                            const string& challenge );

        virtual void start( u_int16_t channel,
                            u_int8_t versionMajor,
                            u_int8_t versionMinor,
                            const FieldTable& serverProperties,
                            const string& mechanisms,
                            const string& locales );

        virtual void tune( u_int16_t channel,
                            u_int16_t channelMax,
                            u_int32_t frameMax,
                            u_int16_t heartbeat );
    }; // class Connection

    // ==================== class Dtx ====================
    class Dtx : virtual public AMQP_ClientOperations::DtxHandler
    {
    private:
        OutputHandler* out;
        AMQP_ClientProxy* parent;

    public:
        // Constructors and destructors

        Dtx(OutputHandler* out, AMQP_ClientProxy* _parent) : 
            out(out) {parent = _parent;}
        virtual ~Dtx() {}

        // Protocol methods

        virtual void selectOk( u_int16_t channel );

        virtual void startOk( u_int16_t channel );
    }; // class Dtx

    // ==================== class Exchange ====================
    class Exchange : virtual public AMQP_ClientOperations::ExchangeHandler
    {
    private:
        OutputHandler* out;
        AMQP_ClientProxy* parent;

    public:
        // Constructors and destructors

        Exchange(OutputHandler* out, AMQP_ClientProxy* _parent) : 
            out(out) {parent = _parent;}
        virtual ~Exchange() {}

        // Protocol methods

        virtual void declareOk( u_int16_t channel );

        virtual void deleteOk( u_int16_t channel );
    }; // class Exchange

    // ==================== class File ====================
    class File : virtual public AMQP_ClientOperations::FileHandler
    {
    private:
        OutputHandler* out;
        AMQP_ClientProxy* parent;

    public:
        // Constructors and destructors

        File(OutputHandler* out, AMQP_ClientProxy* _parent) : 
            out(out) {parent = _parent;}
        virtual ~File() {}

        // Protocol methods

        virtual void cancelOk( u_int16_t channel,
                            const string& consumerTag );

        virtual void consumeOk( u_int16_t channel,
                            const string& consumerTag );

        virtual void deliver( u_int16_t channel,
                            const string& consumerTag,
                            u_int64_t deliveryTag,
                            bool redelivered,
                            const string& exchange,
                            const string& routingKey,
                            const string& identifier );

        virtual void open( u_int16_t channel,
                            const string& identifier,
                            u_int64_t contentSize );

        virtual void openOk( u_int16_t channel,
                            u_int64_t stagedSize );

        virtual void qosOk( u_int16_t channel );

        virtual void return_( u_int16_t channel,
                            u_int16_t replyCode,
                            const string& replyText,
                            const string& exchange,
                            const string& routingKey );

        virtual void stage( u_int16_t channel );
    }; // class File

    // ==================== class Queue ====================
    class Queue : virtual public AMQP_ClientOperations::QueueHandler
    {
    private:
        OutputHandler* out;
        AMQP_ClientProxy* parent;

    public:
        // Constructors and destructors

        Queue(OutputHandler* out, AMQP_ClientProxy* _parent) : 
            out(out) {parent = _parent;}
        virtual ~Queue() {}

        // Protocol methods

        virtual void bindOk( u_int16_t channel );

        virtual void declareOk( u_int16_t channel,
                            const string& queue,
                            u_int32_t messageCount,
                            u_int32_t consumerCount );

        virtual void deleteOk( u_int16_t channel,
                            u_int32_t messageCount );

        virtual void purgeOk( u_int16_t channel,
                            u_int32_t messageCount );
    }; // class Queue

    // ==================== class Stream ====================
    class Stream : virtual public AMQP_ClientOperations::StreamHandler
    {
    private:
        OutputHandler* out;
        AMQP_ClientProxy* parent;

    public:
        // Constructors and destructors

        Stream(OutputHandler* out, AMQP_ClientProxy* _parent) : 
            out(out) {parent = _parent;}
        virtual ~Stream() {}

        // Protocol methods

        virtual void cancelOk( u_int16_t channel,
                            const string& consumerTag );

        virtual void consumeOk( u_int16_t channel,
                            const string& consumerTag );

        virtual void deliver( u_int16_t channel,
                            const string& consumerTag,
                            u_int64_t deliveryTag,
                            const string& exchange,
                            const string& queue );

        virtual void qosOk( u_int16_t channel );

        virtual void return_( u_int16_t channel,
                            u_int16_t replyCode,
                            const string& replyText,
                            const string& exchange,
                            const string& routingKey );
    }; // class Stream

    // ==================== class Test ====================
    class Test : virtual public AMQP_ClientOperations::TestHandler
    {
    private:
        OutputHandler* out;
        AMQP_ClientProxy* parent;

    public:
        // Constructors and destructors

        Test(OutputHandler* out, AMQP_ClientProxy* _parent) : 
            out(out) {parent = _parent;}
        virtual ~Test() {}

        // Protocol methods

        virtual void content( u_int16_t channel );

        virtual void contentOk( u_int16_t channel,
                            u_int32_t contentChecksum );

        virtual void integer( u_int16_t channel,
                            u_int8_t integer1,
                            u_int16_t integer2,
                            u_int32_t integer3,
                            u_int64_t integer4,
                            u_int8_t operation );

        virtual void integerOk( u_int16_t channel,
                            u_int64_t result );

        virtual void string_( u_int16_t channel,
                            const string& string1,
                            const string& string2,
                            u_int8_t operation );

        virtual void stringOk( u_int16_t channel,
                            const string& result );

        virtual void table( u_int16_t channel,
                            const FieldTable& table,
                            u_int8_t integerOp,
                            u_int8_t stringOp );

        virtual void tableOk( u_int16_t channel,
                            u_int64_t integerResult,
                            const string& stringResult );
    }; // class Test

    // ==================== class Tunnel ====================
    class Tunnel : virtual public AMQP_ClientOperations::TunnelHandler
    {
    private:
        OutputHandler* out;
        AMQP_ClientProxy* parent;

    public:
        // Constructors and destructors

        Tunnel(OutputHandler* out, AMQP_ClientProxy* _parent) : 
            out(out) {parent = _parent;}
        virtual ~Tunnel() {}

        // Protocol methods

    }; // class Tunnel

    // ==================== class Tx ====================
    class Tx : virtual public AMQP_ClientOperations::TxHandler
    {
    private:
        OutputHandler* out;
        AMQP_ClientProxy* parent;

    public:
        // Constructors and destructors

        Tx(OutputHandler* out, AMQP_ClientProxy* _parent) : 
            out(out) {parent = _parent;}
        virtual ~Tx() {}

        // Protocol methods

        virtual void commitOk( u_int16_t channel );

        virtual void rollbackOk( u_int16_t channel );

        virtual void selectOk( u_int16_t channel );
    }; // class Tx

private:
	// Inner class instances
	
    Access access;
    Basic basic;
    Channel channel;
    Connection connection;
    Dtx dtx;
    Exchange exchange;
    File file;
    Queue queue;
    Stream stream;
    Test test;
    Tunnel tunnel;
    Tx tx;

public:
	// Inner class instance get methods
	
    Access& getAccess();
    Basic& getBasic();
    Channel& getChannel();
    Connection& getConnection();
    Dtx& getDtx();
    Exchange& getExchange();
    File& getFile();
    Queue& getQueue();
    Stream& getStream();
    Test& getTest();
    Tunnel& getTunnel();
    Tx& getTx();
    
}; /* class AMQP_ClientProxy */

} /* namespace framing */
} /* namespace qpid */

#endif
