/*
 *
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 * 
 *   http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 *
 */

/*
 * This file is auto-generated by Qpid Gentools v.0.1 - do not modify.
 * Supported AMQP versions:
 *   8-0
 */

#ifndef qpid_framing_BasicGetBody__
#define qpid_framing_BasicGetBody__

#include <string>
#include <sstream>

#include <amqp_types.h>
#include <AMQMethodBody.h>
#include <Buffer.h>
#include <FieldTable.h>

namespace qpid
{
namespace framing
{

 
class BasicGetBody : public AMQMethodBody
{
	// Method field declarations

    u_int16_t ticket;
    string queue;
    bool noAck;
     

public:
    typedef boost::shared_ptr<BasicGetBody> shared_ptr;

	// Constructors and destructors

    BasicGetBody(ProtocolVersion& version,
        u_int16_t ticket,
        const string& queue,
        bool noAck
        ) :
        AMQMethodBody(version),
        ticket(ticket),
        queue(queue),
        noAck(noAck)
    { }


    inline BasicGetBody(u_int8_t major, u_int8_t minor): AMQMethodBody(major, minor) {}
    inline BasicGetBody(ProtocolVersion& version): AMQMethodBody(version) {}
    virtual ~BasicGetBody() {}
    
    // Attribute get methods

    inline u_int16_t getTicket() { return ticket; }
    inline const string& getQueue() { return queue; }
    inline bool getNoAck() { return noAck; }

    // Helper methods
    
    inline void print(std::ostream& out) const
    {
	    out << "BasicGet: ";
        out << "ticket=" << ticket;
        out << "; queue=" << queue;
        out << "; noAck=" << noAck;
    }

    inline u_int16_t amqpClassId() const
    {
    	return 60;
    }
    
    inline u_int16_t amqpMethodId() const
    {
    	return 70;
    }

    inline u_int32_t bodySize() const
    {
		u_int32_t size = 0;        
        size += 2; /* ticket: short */
        size += 1 + queue.length(); /* queue: shortstr */
        size += 1; /* noAck: bit */
        return size;
    }

    inline void encodeContent(Buffer& buffer) const
    {
        buffer.putShort(ticket); /* ticket: short */
        buffer.putShortString(queue); /* queue: shortstr */
        u_int8_t flags_2[1] = {0};
        flags_2[0] |= noAck << 0; /* noAck: bit */
        buffer.putOctet(flags_2[0]);
    }

    inline void decodeContent(Buffer& buffer)
    {
        ticket = buffer.getShort(); /* ticket: short */
        buffer.getShortString(queue); /* queue: shortstr */
        u_int8_t flags_2[1];
        flags_2[0] = buffer.getOctet();
        noAck = (1 << 0) & flags_2[0]; /* noAck: bit */
    }       

    inline void invoke(AMQP_ServerOperations& target, u_int16_t channel)
    {
        target.getBasicHandler()->get(channel,
                    ticket,
                    queue,
                    noAck
                    );
    }


}; // class BasicGetBody


} // namespace framing
} // namespace qpid

#endif

