/*
 *
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 * 
 *   http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 *
 */

/*
 * This file is auto-generated by Qpid Gentools v.0.1 - do not modify.
 * Supported AMQP versions:
 *   8-0
 */

#ifndef qpid_framing_FileQosBody__
#define qpid_framing_FileQosBody__

#include <string>
#include <sstream>

#include <amqp_types.h>
#include <AMQMethodBody.h>
#include <Buffer.h>
#include <FieldTable.h>

namespace qpid
{
namespace framing
{

 
class FileQosBody : public AMQMethodBody
{
	// Method field declarations

    u_int32_t prefetchSize;
    u_int16_t prefetchCount;
    bool global;
     

public:
    typedef boost::shared_ptr<FileQosBody> shared_ptr;

	// Constructors and destructors

    FileQosBody(ProtocolVersion& version,
        u_int32_t prefetchSize,
        u_int16_t prefetchCount,
        bool global
        ) :
        AMQMethodBody(version),
        prefetchSize(prefetchSize),
        prefetchCount(prefetchCount),
        global(global)
    { }


    inline FileQosBody(u_int8_t major, u_int8_t minor): AMQMethodBody(major, minor) {}
    inline FileQosBody(ProtocolVersion& version): AMQMethodBody(version) {}
    virtual ~FileQosBody() {}
    
    // Attribute get methods

    inline u_int32_t getPrefetchSize() { return prefetchSize; }
    inline u_int16_t getPrefetchCount() { return prefetchCount; }
    inline bool getGlobal() { return global; }

    // Helper methods
    
    inline void print(std::ostream& out) const
    {
	    out << "FileQos: ";
        out << "prefetchSize=" << prefetchSize;
        out << "; prefetchCount=" << prefetchCount;
        out << "; global=" << global;
    }

    inline u_int16_t amqpClassId() const
    {
    	return 70;
    }
    
    inline u_int16_t amqpMethodId() const
    {
    	return 10;
    }

    inline u_int32_t bodySize() const
    {
		u_int32_t size = 0;        
        size += 4; /* prefetchSize: long */
        size += 2; /* prefetchCount: short */
        size += 1; /* global: bit */
        return size;
    }

    inline void encodeContent(Buffer& buffer) const
    {
        buffer.putLong(prefetchSize); /* prefetchSize: long */
        buffer.putShort(prefetchCount); /* prefetchCount: short */
        u_int8_t flags_2[1] = {0};
        flags_2[0] |= global << 0; /* global: bit */
        buffer.putOctet(flags_2[0]);
    }

    inline void decodeContent(Buffer& buffer)
    {
        prefetchSize = buffer.getLong(); /* prefetchSize: long */
        prefetchCount = buffer.getShort(); /* prefetchCount: short */
        u_int8_t flags_2[1];
        flags_2[0] = buffer.getOctet();
        global = (1 << 0) & flags_2[0]; /* global: bit */
    }       

    inline void invoke(AMQP_ServerOperations& target, u_int16_t channel)
    {
        target.getFileHandler()->qos(channel,
                    prefetchSize,
                    prefetchCount,
                    global
                    );
    }


}; // class FileQosBody


} // namespace framing
} // namespace qpid

#endif

