/*
 *
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 * 
 *   http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 *
 */

/*
 * This file is auto-generated by Qpid Gentools v.0.1 - do not modify.
 * Supported AMQP versions:
 *   8-0
 */

#ifndef qpid_framing_FileStageBody__
#define qpid_framing_FileStageBody__

#include <string>
#include <sstream>

#include <amqp_types.h>
#include <AMQMethodBody.h>
#include <Buffer.h>
#include <FieldTable.h>

namespace qpid
{
namespace framing
{

 
class FileStageBody : public AMQMethodBody
{
	// Method field declarations

     

public:
    typedef boost::shared_ptr<FileStageBody> shared_ptr;

	// Constructors and destructors



    inline FileStageBody(u_int8_t major, u_int8_t minor): AMQMethodBody(major, minor) {}
    inline FileStageBody(ProtocolVersion& version): AMQMethodBody(version) {}
    virtual ~FileStageBody() {}
    
    // Attribute get methods


    // Helper methods
    
    inline void print(std::ostream& out) const
    {
	    out << "FileStage: ";
    }

    inline u_int16_t amqpClassId() const
    {
    	return 70;
    }
    
    inline u_int16_t amqpMethodId() const
    {
    	return 50;
    }

    inline u_int32_t bodySize() const
    {
		u_int32_t size = 0;        
        return size;
    }

    inline void encodeContent(Buffer&) const
    {
    }

    inline void decodeContent(Buffer&)
    {
    }       

    inline void invoke(AMQP_ServerOperations& target, u_int16_t channel)
    {
        target.getFileHandler()->stage(channel);
    }


}; // class FileStageBody


} // namespace framing
} // namespace qpid

#endif

