/*
 *
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 * 
 *   http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 *
 */

/*
 * This file is auto-generated by Qpid Gentools v.0.1 - do not modify.
 * Supported AMQP versions:
 *   8-0
 */

#ifndef qpid_framing_QueueDeclareBody__
#define qpid_framing_QueueDeclareBody__

#include <string>
#include <sstream>

#include <amqp_types.h>
#include <AMQMethodBody.h>
#include <Buffer.h>
#include <FieldTable.h>

namespace qpid
{
namespace framing
{

 
class QueueDeclareBody : public AMQMethodBody
{
	// Method field declarations

    u_int16_t ticket;
    string queue;
    bool passive;
    bool durable;
    bool exclusive;
    bool autoDelete;
    bool nowait;
    FieldTable arguments;
     

public:
    typedef boost::shared_ptr<QueueDeclareBody> shared_ptr;

	// Constructors and destructors

    QueueDeclareBody(ProtocolVersion& version,
        u_int16_t ticket,
        const string& queue,
        bool passive,
        bool durable,
        bool exclusive,
        bool autoDelete,
        bool nowait,
        const FieldTable& arguments
        ) :
        AMQMethodBody(version),
        ticket(ticket),
        queue(queue),
        passive(passive),
        durable(durable),
        exclusive(exclusive),
        autoDelete(autoDelete),
        nowait(nowait),
        arguments(arguments)
    { }


    inline QueueDeclareBody(u_int8_t major, u_int8_t minor): AMQMethodBody(major, minor) {}
    inline QueueDeclareBody(ProtocolVersion& version): AMQMethodBody(version) {}
    virtual ~QueueDeclareBody() {}
    
    // Attribute get methods

    inline u_int16_t getTicket() { return ticket; }
    inline const string& getQueue() { return queue; }
    inline bool getPassive() { return passive; }
    inline bool getDurable() { return durable; }
    inline bool getExclusive() { return exclusive; }
    inline bool getAutoDelete() { return autoDelete; }
    inline bool getNowait() { return nowait; }
    inline const FieldTable& getArguments() { return arguments; }

    // Helper methods
    
    inline void print(std::ostream& out) const
    {
	    out << "QueueDeclare: ";
        out << "ticket=" << ticket;
        out << "; queue=" << queue;
        out << "; passive=" << passive;
        out << "; durable=" << durable;
        out << "; exclusive=" << exclusive;
        out << "; autoDelete=" << autoDelete;
        out << "; nowait=" << nowait;
        out << "; arguments=" << arguments;
    }

    inline u_int16_t amqpClassId() const
    {
    	return 50;
    }
    
    inline u_int16_t amqpMethodId() const
    {
    	return 10;
    }

    inline u_int32_t bodySize() const
    {
		u_int32_t size = 0;        
        size += 2; /* ticket: short */
        size += 1 + queue.length(); /* queue: shortstr */
        size += 1; /* Combinded bits: [passive, durable, exclusive, autoDelete, nowait] */
        size += arguments.size(); /* arguments: table */
        return size;
    }

    inline void encodeContent(Buffer& buffer) const
    {
        buffer.putShort(ticket); /* ticket: short */
        buffer.putShortString(queue); /* queue: shortstr */
        u_int8_t flags_7[1] = {0};
        flags_7[0] |= passive << 0; /* passive: bit */
        flags_7[0] |= durable << 1; /* durable: bit */
        flags_7[0] |= exclusive << 2; /* exclusive: bit */
        flags_7[0] |= autoDelete << 3; /* autoDelete: bit */
        flags_7[0] |= nowait << 4; /* nowait: bit */
        buffer.putOctet(flags_7[0]);
        buffer.putFieldTable(arguments); /* arguments: table */
    }

    inline void decodeContent(Buffer& buffer)
    {
        ticket = buffer.getShort(); /* ticket: short */
        buffer.getShortString(queue); /* queue: shortstr */
        u_int8_t flags_7[1];
        flags_7[0] = buffer.getOctet();
        passive = (1 << 0) & flags_7[0]; /* passive: bit */
        durable = (1 << 1) & flags_7[0]; /* durable: bit */
        exclusive = (1 << 2) & flags_7[0]; /* exclusive: bit */
        autoDelete = (1 << 3) & flags_7[0]; /* autoDelete: bit */
        nowait = (1 << 4) & flags_7[0]; /* nowait: bit */
        buffer.getFieldTable(arguments); /* arguments: table */
    }       

    inline void invoke(AMQP_ServerOperations& target, u_int16_t channel)
    {
        target.getQueueHandler()->declare(channel,
                    ticket,
                    queue,
                    passive,
                    durable,
                    exclusive,
                    autoDelete,
                    nowait,
                    arguments
                    );
    }


}; // class QueueDeclareBody


} // namespace framing
} // namespace qpid

#endif

