/*
 *
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 * 
 *   http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 *
 */

/*
 * This file is auto-generated by Qpid Gentools v.0.1 - do not modify.
 * Supported AMQP versions:
 *   8-0
 */

#ifndef qpid_framing_StreamConsumeOkBody__
#define qpid_framing_StreamConsumeOkBody__

#include <string>
#include <sstream>

#include <amqp_types.h>
#include <AMQMethodBody.h>
#include <Buffer.h>
#include <FieldTable.h>

namespace qpid
{
namespace framing
{

 
class StreamConsumeOkBody : public AMQMethodBody
{
	// Method field declarations

    string consumerTag;
     

public:
    typedef boost::shared_ptr<StreamConsumeOkBody> shared_ptr;

	// Constructors and destructors

    StreamConsumeOkBody(ProtocolVersion& version,
        const string& consumerTag
        ) :
        AMQMethodBody(version),
        consumerTag(consumerTag)
    { }


    inline StreamConsumeOkBody(u_int8_t major, u_int8_t minor): AMQMethodBody(major, minor) {}
    inline StreamConsumeOkBody(ProtocolVersion& version): AMQMethodBody(version) {}
    virtual ~StreamConsumeOkBody() {}
    
    // Attribute get methods

    inline const string& getConsumerTag() { return consumerTag; }

    // Helper methods
    
    inline void print(std::ostream& out) const
    {
	    out << "StreamConsumeOk: ";
        out << "consumerTag=" << consumerTag;
    }

    inline u_int16_t amqpClassId() const
    {
    	return 80;
    }
    
    inline u_int16_t amqpMethodId() const
    {
    	return 21;
    }

    inline u_int32_t bodySize() const
    {
		u_int32_t size = 0;        
        size += 1 + consumerTag.length(); /* consumerTag: shortstr */
        return size;
    }

    inline void encodeContent(Buffer& buffer) const
    {
        buffer.putShortString(consumerTag); /* consumerTag: shortstr */
    }

    inline void decodeContent(Buffer& buffer)
    {
        buffer.getShortString(consumerTag); /* consumerTag: shortstr */
    }       



}; // class StreamConsumeOkBody


} // namespace framing
} // namespace qpid

#endif

