/*
 *
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 * 
 *   http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 *
 */

/*
 * This file is auto-generated by Qpid Gentools v.0.1 - do not modify.
 * Supported AMQP versions:
 *   8-0
 */

#ifndef qpid_framing_TestContentOkBody__
#define qpid_framing_TestContentOkBody__

#include <string>
#include <sstream>

#include <amqp_types.h>
#include <AMQMethodBody.h>
#include <Buffer.h>
#include <FieldTable.h>

namespace qpid
{
namespace framing
{

 
class TestContentOkBody : public AMQMethodBody
{
	// Method field declarations

    u_int32_t contentChecksum;
     

public:
    typedef boost::shared_ptr<TestContentOkBody> shared_ptr;

	// Constructors and destructors

    TestContentOkBody(ProtocolVersion& version,
        u_int32_t contentChecksum
        ) :
        AMQMethodBody(version),
        contentChecksum(contentChecksum)
    { }


    inline TestContentOkBody(u_int8_t major, u_int8_t minor): AMQMethodBody(major, minor) {}
    inline TestContentOkBody(ProtocolVersion& version): AMQMethodBody(version) {}
    virtual ~TestContentOkBody() {}
    
    // Attribute get methods

    inline u_int32_t getContentChecksum() { return contentChecksum; }

    // Helper methods
    
    inline void print(std::ostream& out) const
    {
	    out << "TestContentOk: ";
        out << "contentChecksum=" << contentChecksum;
    }

    inline u_int16_t amqpClassId() const
    {
    	return 120;
    }
    
    inline u_int16_t amqpMethodId() const
    {
    	return 41;
    }

    inline u_int32_t bodySize() const
    {
		u_int32_t size = 0;        
        size += 4; /* contentChecksum: long */
        return size;
    }

    inline void encodeContent(Buffer& buffer) const
    {
        buffer.putLong(contentChecksum); /* contentChecksum: long */
    }

    inline void decodeContent(Buffer& buffer)
    {
        contentChecksum = buffer.getLong(); /* contentChecksum: long */
    }       

    inline void invoke(AMQP_ServerOperations& target, u_int16_t channel)
    {
        target.getTestHandler()->contentOk(channel,
                    contentChecksum
                    );
    }


}; // class TestContentOkBody


} // namespace framing
} // namespace qpid

#endif

